const tagView = {
  state: {
    visitedViews: [],
    cachedViews: []
  },
  mutations: {
    F_ADD_VISITED_VIEWS: (state, view) => {
      if (state.visitedViews.some(v => v.path === view.path)) return
      if (view.path === '/') return
      state.visitedViews.push(
        Object.assign({}, view, {
          title: view.meta.title || 'no-name'
        })
      )
      if (!view.meta.noCache) {
        state.cachedViews.push(view.name)
      }
    },
    F_DEL_ALL_VIEWS: state => {
      state.visitedViews = []
      state.cachedViews = []
    }
  },
  actions: {
    addVisitedViews({ commit }, view) {
      commit('F_ADD_VISITED_VIEWS', view)
    },
    delAllViews({ commit, state }) {
      return new Promise(resolve => {
        commit('F_DEL_ALL_VIEWS')
        resolve([...state.visitedViews])
      })
    }
  }
}
export default tagView
